diff --git a/gcc/testsuite/g++.target/riscv/redundant-bitmap-1.C b/gcc/testsuite/g++.target/riscv/redundant-bitmap-1.C
index 37066f10eea..62bb2ab7b67 100644
--- a/gcc/testsuite/g++.target/riscv/redundant-bitmap-1.C
+++ b/gcc/testsuite/g++.target/riscv/redundant-bitmap-1.C
@@ -1,5 +1,5 @@
 /* { dg-do compile } */
-/* { dg-options "-O2 -march=rv64gc_zba_zbb_zbs -mabi=lp64" } */
+/* { dg-options "-O2 -march=rv64gcb -mabi=lp64" } */
 
 void setBit(char &a, int b) {
     char c = 0x1UL << b;
diff --git a/gcc/testsuite/g++.target/riscv/redundant-bitmap-2.C b/gcc/testsuite/g++.target/riscv/redundant-bitmap-2.C
index 86acaba298f..52204daecd1 100644
--- a/gcc/testsuite/g++.target/riscv/redundant-bitmap-2.C
+++ b/gcc/testsuite/g++.target/riscv/redundant-bitmap-2.C
@@ -1,5 +1,5 @@
 /* { dg-do compile } */
-/* { dg-options "-O2 -march=rv64gc_zba_zbb_zbs -mabi=lp64" } */
+/* { dg-options "-O2 -march=rv64gcb -mabi=lp64" } */
 
 void setBit(char &a, int b) {
     char c = 0x1UL << b;
diff --git a/gcc/testsuite/g++.target/riscv/redundant-bitmap-3.C b/gcc/testsuite/g++.target/riscv/redundant-bitmap-3.C
index 16bd7c1785e..6745220f2f4 100644
--- a/gcc/testsuite/g++.target/riscv/redundant-bitmap-3.C
+++ b/gcc/testsuite/g++.target/riscv/redundant-bitmap-3.C
@@ -1,5 +1,5 @@
 /* { dg-do compile } */
-/* { dg-options "-O2 -march=rv64gc_zba_zbb_zbs -mabi=lp64" } */
+/* { dg-options "-O2 -march=rv64gcb -mabi=lp64" } */
 
 void setBit(char &a, int b) {
     char c = 0x1UL << b;
diff --git a/gcc/testsuite/g++.target/riscv/redundant-bitmap-4.C b/gcc/testsuite/g++.target/riscv/redundant-bitmap-4.C
index f664ee01a01..5e351fe457e 100644
--- a/gcc/testsuite/g++.target/riscv/redundant-bitmap-4.C
+++ b/gcc/testsuite/g++.target/riscv/redundant-bitmap-4.C
@@ -1,5 +1,5 @@
 /* { dg-do compile } */
-/* { dg-options "-O2 -march=rv64gc_zba_zbb_zbs -mabi=lp64" } */
+/* { dg-options "-O2 -march=rv64gcb -mabi=lp64" } */
 
 void setBit(char &a, int b) {
     char c = 0x1UL << b;
diff --git a/gcc/testsuite/gcc.target/riscv/shift-add-1.c b/gcc/testsuite/gcc.target/riscv/shift-add-1.c
index d98875c3271..db84a51a222 100644
--- a/gcc/testsuite/gcc.target/riscv/shift-add-1.c
+++ b/gcc/testsuite/gcc.target/riscv/shift-add-1.c
@@ -1,5 +1,5 @@
 /* { dg-do compile } */
-/* { dg-options "-march=rv64gc_zba_zbb_zbs -mabi=lp64" } */
+/* { dg-options "-march=rv64gcb -mabi=lp64" } */
 /* { dg-skip-if "" { *-*-* } { "-O0" "-Og" } } */
 
 int composeFromSurrogate(const unsigned short high) {
diff --git a/gcc/testsuite/gcc.target/riscv/shift-add-2.c b/gcc/testsuite/gcc.target/riscv/shift-add-2.c
index 87439858e59..ed95ced5b85 100644
--- a/gcc/testsuite/gcc.target/riscv/shift-add-2.c
+++ b/gcc/testsuite/gcc.target/riscv/shift-add-2.c
@@ -1,5 +1,5 @@
 /* { dg-do compile } */
-/* { dg-options "-march=rv64gc_zba_zbb_zbs -mabi=lp64" } */
+/* { dg-options "-march=rv64gcb -mabi=lp64" } */
 /* { dg-skip-if "" { *-*-* } { "-O0" "-Og" } } */
 
 int sub2(int a, long long b) {
diff --git a/gcc/testsuite/gcc.target/riscv/synthesis-1.c b/gcc/testsuite/gcc.target/riscv/synthesis-1.c
index 9176d5f4989..c50abb08330 100644
--- a/gcc/testsuite/gcc.target/riscv/synthesis-1.c
+++ b/gcc/testsuite/gcc.target/riscv/synthesis-1.c
@@ -5,7 +5,7 @@
    and eliminates the usual sources of extraneous dead code that would throw
    off the counts.  */
 /* { dg-skip-if "" { *-*-* } { "-O0" "-Og" "-O2" "-O3" "-Os" "-Oz" "-flto" } } */
-/* { dg-options "-march=rv64gc_zba_zbb_zbs" } */
+/* { dg-options "-march=rv64gcb" } */
 
 /* Rather than test for a specific synthesis of all these constants or
    having thousands of tests each testing one variant, we just test the
diff --git a/gcc/testsuite/gcc.target/riscv/synthesis-2.c b/gcc/testsuite/gcc.target/riscv/synthesis-2.c
index b88374da3c4..82383408f77 100644
--- a/gcc/testsuite/gcc.target/riscv/synthesis-2.c
+++ b/gcc/testsuite/gcc.target/riscv/synthesis-2.c
@@ -5,7 +5,7 @@
    and eliminates the usual sources of extraneous dead code that would throw
    off the counts.  */
 /* { dg-skip-if "" { *-*-* } { "-O0" "-Og" "-O2" "-O3" "-Os" "-Oz" "-flto" } } */
-/* { dg-options "-march=rv64gc_zba_zbb_zbs" } */
+/* { dg-options "-march=rv64gcb" } */
 
 /* All these cases have the same form.  lui+slli.uw+addi
 /* { dg-final { scan-assembler-times "\\tadd" 367 } } */
diff --git a/gcc/testsuite/gcc.target/riscv/synthesis-3.c b/gcc/testsuite/gcc.target/riscv/synthesis-3.c
index 5d92ac8e309..88ef0e81203 100644
--- a/gcc/testsuite/gcc.target/riscv/synthesis-3.c
+++ b/gcc/testsuite/gcc.target/riscv/synthesis-3.c
@@ -5,7 +5,7 @@
    and eliminates the usual sources of extraneous dead code that would throw
    off the counts.  */
 /* { dg-skip-if "" { *-*-* } { "-O0" "-Og" "-O2" "-O3" "-Os" "-Oz" "-flto" } } */
-/* { dg-options "-march=rv64gc_zba_zbb_zbs" } */
+/* { dg-options "-march=rv64gcb" } */
 
 /* Rather than test for a specific synthesis of all these constants or
    having thousands of tests each testing one variant, we just test the
diff --git a/gcc/testsuite/gcc.target/riscv/synthesis-4.c b/gcc/testsuite/gcc.target/riscv/synthesis-4.c
index 328a55b9e6e..54d25e2681f 100644
--- a/gcc/testsuite/gcc.target/riscv/synthesis-4.c
+++ b/gcc/testsuite/gcc.target/riscv/synthesis-4.c
@@ -5,7 +5,7 @@
    and eliminates the usual sources of extraneous dead code that would throw
    off the counts.  */
 /* { dg-skip-if "" { *-*-* } { "-O0" "-Og" "-O2" "-O3" "-Os" "-Oz" "-flto" } } */
-/* { dg-options "-march=rv64gc_zba_zbb_zbs" } */
+/* { dg-options "-march=rv64gcb" } */
 
 /* Rather than test for a specific synthesis of all these constants or
    having thousands of tests each testing one variant, we just test the
diff --git a/gcc/testsuite/gcc.target/riscv/synthesis-5.c b/gcc/testsuite/gcc.target/riscv/synthesis-5.c
index 4d81565b563..4ed07e4def5 100644
--- a/gcc/testsuite/gcc.target/riscv/synthesis-5.c
+++ b/gcc/testsuite/gcc.target/riscv/synthesis-5.c
@@ -6,7 +6,7 @@
    and eliminates the usual sources of extraneous dead code that would throw
    off the counts.  */
 /* { dg-skip-if "" { *-*-* } { "-O0" "-Og" "-O2" "-O3" "-Os" "-Oz" "-flto" } } */
-/* { dg-options "-march=rv64gc_zba_zbb_zbs" } */
+/* { dg-options "-march=rv64gcb" } */
 
 /* Rather than test for a specific synthesis of all these constants or
    having thousands of tests each testing one variant, we just test the
diff --git a/gcc/testsuite/gcc.target/riscv/synthesis-6.c b/gcc/testsuite/gcc.target/riscv/synthesis-6.c
index 65cf748f4b5..2304855fbd1 100644
--- a/gcc/testsuite/gcc.target/riscv/synthesis-6.c
+++ b/gcc/testsuite/gcc.target/riscv/synthesis-6.c
@@ -5,7 +5,7 @@
    and eliminates the usual sources of extraneous dead code that would throw
    off the counts.  */
 /* { dg-skip-if "" { *-*-* } { "-O0" "-Og" "-O2" "-O3" "-Os" "-Oz" "-flto" } } */
-/* { dg-options "-march=rv64gc_zba_zbb_zbs" } */
+/* { dg-options "-march=rv64gcb" } */
 
 /* Rather than test for a specific synthesis of all these constants or
    having thousands of tests each testing one variant, we just test the
diff --git a/gcc/testsuite/gcc.target/riscv/synthesis-7.c b/gcc/testsuite/gcc.target/riscv/synthesis-7.c
index 1611c964758..5a69d2e5f21 100644
--- a/gcc/testsuite/gcc.target/riscv/synthesis-7.c
+++ b/gcc/testsuite/gcc.target/riscv/synthesis-7.c
@@ -5,7 +5,7 @@
    and eliminates the usual sources of extraneous dead code that would throw
    off the counts.  */
 /* { dg-skip-if "" { *-*-* } { "-O0" "-Og" "-O2" "-O3" "-Os" "-Oz" "-flto" } } */
-/* { dg-options "-march=rv64gc_zba_zbb_zbs" } */
+/* { dg-options "-march=rv64gcb" } */
 
 /* Rather than test for a specific synthesis of all these constants or
    having thousands of tests each testing one variant, we just test the
diff --git a/gcc/testsuite/gcc.target/riscv/synthesis-8.c b/gcc/testsuite/gcc.target/riscv/synthesis-8.c
index 2bcdb4e774d..72fd7113321 100644
--- a/gcc/testsuite/gcc.target/riscv/synthesis-8.c
+++ b/gcc/testsuite/gcc.target/riscv/synthesis-8.c
@@ -5,7 +5,7 @@
    and eliminates the usual sources of extraneous dead code that would throw
    off the counts.  */
 /* { dg-skip-if "" { *-*-* } { "-O0" "-Og" "-O2" "-O3" "-Os" "-Oz" "-flto" } } */
-/* { dg-options "-march=rv64gc_zba_zbb_zbs" } */
+/* { dg-options "-march=rv64gcb" } */
 
 /* Rather than test for a specific synthesis of all these constants or
    having thousands of tests each testing one variant, we just test the
diff --git a/gcc/testsuite/gcc.target/riscv/zba_zbs_and-1.c b/gcc/testsuite/gcc.target/riscv/zba_zbs_and-1.c
index 23fd769449e..ddff91a4e7c 100644
--- a/gcc/testsuite/gcc.target/riscv/zba_zbs_and-1.c
+++ b/gcc/testsuite/gcc.target/riscv/zba_zbs_and-1.c
@@ -1,5 +1,5 @@
 /* { dg-do compile } */
-/* { dg-options "-march=rv64gc_zba_zbb_zbs -mabi=lp64" } */
+/* { dg-options "-march=rv64gcb -mabi=lp64" } */
 /* { dg-skip-if "" { *-*-* } { "-O0" "-Og" } } */
 
 
diff --git a/gcc/testsuite/gcc.target/riscv/zbs-zext-3.c b/gcc/testsuite/gcc.target/riscv/zbs-zext-3.c
index 0239014e06b..8dc3f289778 100644
--- a/gcc/testsuite/gcc.target/riscv/zbs-zext-3.c
+++ b/gcc/testsuite/gcc.target/riscv/zbs-zext-3.c
@@ -1,6 +1,6 @@
 /* { dg-do compile } */
-/* { dg-options "-march=rv64gc_zba_zbb_zbs -mabi=lp64d" { target { rv64 } } } */
-/* { dg-options "-march=rv32gc_zba_zbb_zbs -mabi=ilp32" { target { rv32 } } } */
+/* { dg-options "-march=rv64gcb -mabi=lp64d" { target { rv64 } } } */
+/* { dg-options "-march=rv32gcb -mabi=ilp32" { target { rv32 } } } */
 /* { dg-skip-if "" { *-*-* } { "-O0" "-Og" } } */
 
 /* We need to adjust the constant so this works for rv32 and rv64.  */
diff --git a/gcc/testsuite/lib/target-supports.exp b/gcc/testsuite/lib/target-supports.exp
index d3edc7d839e..f001c28072f 100644
--- a/gcc/testsuite/lib/target-supports.exp
+++ b/gcc/testsuite/lib/target-supports.exp
@@ -2140,7 +2140,7 @@ proc check_effective_target_riscv_v_misalign_ok { } {
 proc riscv_get_arch { } {
     set gcc_march ""
     # ??? do we neeed to add more extensions to the list below?
-    foreach ext { i m a f d q c v zicsr zifencei zfh zba zbb zbc zbs zvbb zvfh ztso zaamo zalrsc zabha } {
+    foreach ext { i m a f d q c b v zicsr zifencei zfh zba zbb zbc zbs zvbb zvfh ztso zaamo zalrsc zabha } {
 	if { [check_no_compiler_messages  riscv_ext_$ext assembly [string map [list DEF __riscv_$ext] {
 		#ifndef DEF
 		#error "Not DEF"